library ieee;
use ieee.std_logic_1164.all;

entity adder is
  generic(left: integer range 0 to 31);
  port ( a,b: in std_logic_vector(left downto 0);
          r: out std_logic_vector(left downto 0) );
  end adder;
  
  architecture beh of adder is
  
   function i2slv ( num: integer; dim: integer)
     return std_logic_vector is
    variable temp: std_logic_vector(dim-1 downto 0);
    variable quoziente, i: integer;
    begin
    
    quoziente:= num;
    if quoziente < 0 then quoziente := -quoziente;
    end if;
    temp:= (others => '0');
    for i in 0 to dim-1 loop
      if quoziente mod 2 = 1 then temp(i):='1';
      end if;
      quoziente:= quoziente /2;
      exit when quoziente=0;
    end loop;
    if num<0 then
    i:=0;
    while i<dim and temp(i) ='0' loop
     i:= i+1;
   end loop;
    i:=i+1;
    while(i<dim) loop
      temp(i):= not temp(i);
      i:=i+1;
    end loop;
  end if;
  return temp;
end i2slv;  
  
  function slv2i (vect: std_logic_vector)
    return integer   is
    variable temp: std_logic_vector(vect'range);
    variable i,dim,risultato: integer;
    
    begin
      dim:= vect'length;
      temp:= vect;
      if temp(dim-1) = '1' then
        i:=0;
        while i<dim and temp(i) ='0' loop
          i:= i+1;
        end loop;
        i:=i+1;
        while(i<dim) loop
          temp(i):= not temp(i);
          i:=i+1;
        end loop;
      end if;
      risultato:=0;
      for i in dim-1 downto 0 loop
        risultato:= risultato*2;
        if temp(i)= '1' then 
           risultato:= risultato+1;
      end if;
    end loop;
    if vect(dim-1)='1' then
      risultato := -risultato;
    end  if;
    return risultato;
 end slv2i;
 
 begin
   r<= i2slv(slv2i(a)+slv2i(b),left+1); 
 end beh;      